//+------------------------------------------------------------------+
//|                                               Custom BB_MACD.mq4 |
//|                                     Copyright  2005, adoleh2000 |
//|                                       http://www.metaquotes.net/ 
//| fixed by superblacksmith and modified by marley60
//+------------------------------------------------------------------+

#property  copyright "Copyright  2005, adoleh2000"
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 7
#property  indicator_color1  Magenta//Lime    //bbMacd up
#property  indicator_color2  Lime//Magenta //bbMacd up
/*#property  indicator_color3  Blue    //Upperband
#property  indicator_color4  Blue    //Lowerband
#property  indicator_color5  Green   //Up 
#property  indicator_color6  Red     //Down
*/
//---- indicator parameters
extern int FastLen = 21;
extern int SlowLen = 55;
extern int Length = 8;
extern double StDv = 1;
extern double Distance = 0.0001;
/*extern bool soundalert = True;
extern bool boxalert = False;
extern bool emailalert = False;

static datetime soundTag = 0; 
*/
//----
int loopbegin;
int shift;
double zeroline;
//---- indicator buffers
double ExtMapBuffer1[];  // bbMacd
double ExtMapBuffer2[];  // bbMacd
double ExtMapBuffer3[];  // Upperband Line
double ExtMapBuffer4[];  // Lowerband Line
double ExtMapBuffer5[];  // up
double ExtMapBuffer6[];  // down

//---- temp buffers
double bbMacd[];
double Upperband;
double Lowerband;
double avg;

double bbMacdline;
double sDev;
double mean;
double sumSqr;

string alert_message;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 6 additional buffers are used for counting.
   IndicatorBuffers(8);   
//---- drawing settings     
   SetIndexBuffer(0, ExtMapBuffer1); // bbMacd line
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, 108);
   IndicatorDigits(Digits + 1);
//----
   SetIndexBuffer(1, ExtMapBuffer2); // bbMacd line
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1, 108);
   IndicatorDigits(Digits + 1);
//----   
   SetIndexBuffer(2, ExtMapBuffer3); // Upperband line
   SetIndexStyle(2, DRAW_NONE);//LINE, STYLE_SOLID, 1);
   IndicatorDigits(Digits + 1);
//----   
   SetIndexBuffer(3, ExtMapBuffer4); // Lowerband line
   SetIndexStyle(3, DRAW_NONE);//LINE, STYLE_SOLID, 1);
   IndicatorDigits(Digits + 1);

  SetIndexBuffer(4, ExtMapBuffer5); // UP
  SetIndexStyle(4, DRAW_NONE);//ARROW, 0, 4, Green);
  IndicatorDigits(Digits + 1);

   SetIndexBuffer(5, ExtMapBuffer6); // Down
   SetIndexStyle(5, DRAW_NONE);//ARROW, 0, 4, Red);
   IndicatorDigits(Digits + 1);

   SetIndexBuffer(6, bbMacd); // temp buffer for calculations
   SetIndexStyle(6, DRAW_NONE);
  

//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("BB MACD(" + FastLen + "," + SlowLen + "," + Length+")");
   SetIndexLabel(0, "UP bbMacd");
   SetIndexLabel(1, "DN bbMacd");
   SetIndexLabel(2, "Upperband");
   SetIndexLabel(3, "Lowerband");  
   SetIndexLabel(4, "UP Signal");
   SetIndexLabel(5, "DN Signal");  
   SetIndexLabel(6, "bbMacd");  


//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom BB_MACD                                                   |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars = IndicatorCounted();
   bool signal = false;
   bool up = false;
   bool dn = false;
   double pos = 0.03;
   
   if (Digits == 5) pos = 0.0003;
   if (Digits == 4) pos = 0.0003;

//---- check for possible errors
   if(counted_bars < 0) 
       return(-1);
//---- last counted bar will be recounted
   if(counted_bars > 0) 
       counted_bars--;
   limit = Bars - counted_bars;
//----
   for(int i = 0; i < limit; i++)
       bbMacd[i] = iMA(NULL, 0, FastLen, 0, MODE_EMA, PRICE_CLOSE, i) - 
                   iMA(NULL, 0, SlowLen, 0, MODE_EMA, PRICE_CLOSE, i);
//----
   for(i = 0; i < limit; i++)
     {
       avg = iMAOnArray(bbMacd, 0, Length, 0, MODE_EMA, i);
       sDev = iStdDevOnArray(bbMacd, 0, Length, MODE_EMA, 0, i);  
       Upperband = avg + (StDv * sDev);
       Lowerband = avg - (StDv * sDev);
       ExtMapBuffer1[i]=bbMacd[i];     // Uptrend bbMacd
       ExtMapBuffer2[i]=bbMacd[i];     // downtrend bbMacd
       ExtMapBuffer3[i]=Upperband;  // Upperband
       ExtMapBuffer4[i]=Lowerband;  // Lowerband
       //----
       if(bbMacd[i] > bbMacd[i+1])
           ExtMapBuffer2[i] = (Close[i]+ Distance);//EMPTY_VALUE;
       //----
       if(bbMacd[i] < bbMacd[i+1])
           ExtMapBuffer1[i] = (Close[i]- Distance);// EMPTY_VALUE;
/*
// dot has crossed lower line - trigger down signal
      signal = false;
      up = false;
      dn = false;


// dot has changed color       

       if ((ExtMapBuffer1[i+1] == EMPTY_VALUE) && (ExtMapBuffer1[i+2] != EMPTY_VALUE))
          { 
          ExtMapBuffer6[i+1] = bbMacd[i+1] + pos; //trigger down signal
          dn = true;
          signal = true;     
          }

      if ((ExtMapBuffer2[i+1] == EMPTY_VALUE) && (ExtMapBuffer2[i+2] != EMPTY_VALUE)) 

           {
          ExtMapBuffer5[i+1] = bbMacd[i+1] - pos; //trigger up signal
          signal = true;     
          up = true; 
           } 

// dot has crossed lower line - trigger dn signal


      if (ExtMapBuffer1[i+1] == EMPTY_VALUE && !signal)
       
          {
//          if ((MathAbs(ExtMapBuffer2[i+1]) < MathAbs(ExtMapBuffer4[i+1])) 
//          && (MathAbs(ExtMapBuffer2[i+2]) > MathAbs(ExtMapBuffer4[i+2])))

          if (ExtMapBuffer2[i+1] < ExtMapBuffer4[i+1] 
          && ExtMapBuffer2[i+2] > ExtMapBuffer4[i+2])

              { 
              ExtMapBuffer6[i+1] = bbMacd[i+1] + pos;
              signal = true;     
              dn = true;     

              }
          }    

// dot has crossed upper line - trigger up signal

      if (ExtMapBuffer2[i+1] == EMPTY_VALUE && !signal)
      
          {
//          if ((MathAbs(ExtMapBuffer1[i+1]) > MathAbs(ExtMapBuffer3[i+1])) 
//          && (MathAbs(ExtMapBuffer1[i+2]) < MathAbs(ExtMapBuffer3[i+2])))

          if (ExtMapBuffer1[i+1] > ExtMapBuffer3[i+1] 
          && ExtMapBuffer1[i+2] < ExtMapBuffer3[i+2])

              { 
              ExtMapBuffer5[i+1] = bbMacd[i+1] - pos;
              up = True;  
              signal = true;     
              }
          }    


// create alert


       if (soundTag!=Time[0] && i==1)
           {
           if (signal && soundalert==true)
              {
               PlaySound ("train_horn.wav");
               soundTag = Time[0];
              }
           if (signal && up && boxalert==true)
              {
               alert_message = Symbol() + "  " + "Long at " + DoubleToStr(Close[i+1],Digits);
               
               Alert(alert_message);
               soundTag = Time[0];
              }
            if (signal && dn && boxalert==true)
              {
               alert_message = Symbol() + "  " + "Short at " + DoubleToStr(Close[i+1],Digits);
               
               Alert(alert_message);
               soundTag = Time[0];
              }
           if (signal && up && emailalert==true)
              {
               alert_message = Symbol() + "  " + "Long at " + DoubleToStr(Close[i+1],Digits);
               
               SendMail("Renko BBMACD Buy Alert " + Symbol(), alert_message);
               soundTag = Time[0];
              }
            if (signal && dn && emailalert==true)
              {
               alert_message = Symbol() + "  " + "Short at " + DoubleToStr(Close[i+1],Digits);
               
               SendMail("Renko BBMACD Sell Alert" + Symbol(), alert_message);
               soundTag = Time[0];
              }

           }
 */

     }
    
//---- done
   return(0);
  }
//+------------------------------------------------------------------+

